/*
   Copyright (c) 2014 by Plexim GmbH
   All rights reserved.

   A free license is granted to anyone to use this software for any legal
   non safety-critical purpose, including commercial applications, provided
   that:
   1) IT IS NOT USED TO DIRECTLY OR INDIRECTLY COMPETE WITH PLEXIM, and
   2) THIS COPYRIGHT NOTICE IS PRESERVED in its entirety.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
   OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   SOFTWARE.
 */

#include "includes.h"

#ifdef USE_DIRECT_LINK

void IPCMtoCGetMsg(Uint32 ulFlag, Uint32 ulStatusFlag){
	Uint16 *m2cRam;
	Uint16 len;

	m2cRam = (void *)(0x03FC00);

	// Wait until IPC M to C request task is flagged
	while (!(CtoMIpcRegs.MTOCIPCSTS.all & ulFlag)){
		// block
	}

	len = CtoMIpcRegs.MTOCIPCADDR;
	if (len >= PIL_MSG_DATA_LEN){
		CtoMIpcRegs.MTOCIPCDATAR = 1; // buffer overflow error
		CtoMIpcRegs.MTOCIPCACK.all |= (ulFlag); // don't set status flag
	} else {
		// Buffer command
		PIL_RA_parallelIn(m2cRam, len);

		// Acknowledge reception
		CtoMIpcRegs.MTOCIPCDATAR = 0; // no error
		CtoMIpcRegs.MTOCIPCACK.all |= (ulStatusFlag | ulFlag);
	}
}

void IPCCtoMPutMsg(Uint32 ulFlag){
	Uint16 *c2mRam;
	Uint16 len = 0;

	c2mRam = (void *)(0x03F800);

	// is master ready to receive this message?
	if ((CtoMIpcRegs.CTOMIPCFLG.all & ulFlag) != 0){
		// don't block
		return;
	} else {
		PIL_RA_parallelOut((uint16_t *)c2mRam, (uint16_t *)&len);
		if(len > 0){
			// Flag message
			CtoMIpcRegs.CTOMIPCCOM = 0x00020000;
			CtoMIpcRegs.CTOMIPCADDR = len;
			IPCCtoMFlagSet(ulFlag);
		}
	}
}

void IPCPoll(){

}

void IPCPollBackground(){
	if(CtoMIpcRegs.MTOCIPCSTS.all & IPC_FLAG4){
		switch (CtoMIpcRegs.MTOCIPCCOM){

		case 0x00020000:
			IPCMtoCGetMsg(IPC_FLAG4, IPC_FLAG32);
			break;
		}
	}
	// send message (if one is ready)
	IPCCtoMPutMsg(IPC_FLAG1);
}

#endif
